package ocular;

import java.net.SocketException;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import m200.M200Iface;
import m200.messages.M200Msg;
import m200.messages.M200MsgAccept;
import m200.messages.M200MsgCall;
import m200.messages.M200MsgNumber;
import m200.messages.M200MsgSeizure;
import m200.messages.detail.M200MsgReleaseIn;
import m200.messages.detail.M200MsgReleaseOut;

import ocular.handlers.M200MsgCallHdlr;
import ocular.handlers.M200MsgCommonHdlr;
import ocular.handlers.M200MsgHdlr;
import ocular.handlers.M200MsgNumberHdlr;
import ocular.handlers.M200MsgReleaseHdlr;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.dnd.Clipboard;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.events.ShellAdapter;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;


public class Main extends ShellAdapter implements M200Iface.M200MsgReceiver,Listener,KeyListener,Runnable, SelectionListener {
	public HashMap<Integer,M200MsgHdlr> map;
	private Table tableRT;
	private Table tableStat;
	private Table tableCM;
	CallDB currDB;
	private Display display;
	private boolean paused;
	M200Iface mi;
	private Label statusLabel;
	private Color tracedColor;
	private Text nums0;
	private Text nums1;
	private Color tracedBGColor;
	private Clipboard cb; 

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Main main=new Main();
		M200Iface mi=new M200Iface(args[0],Integer.parseInt(args[1]),main);
		main.process(mi);
	}

	public Main(){
		paused=false;
		currDB=new CallDB(40);
		map=new HashMap<Integer,M200MsgHdlr>();
		map.put(M200MsgSeizure.getType(),new M200MsgCommonHdlr());
		map.put(M200MsgCall.getType(),new M200MsgCallHdlr());
		map.put(M200MsgReleaseIn.getType(),new M200MsgReleaseHdlr(/*snmp*/));
		map.put(M200MsgReleaseOut.getType(),new M200MsgCommonHdlr());
		map.put(M200MsgNumber.getType(),new M200MsgNumberHdlr());
		map.put(M200MsgAccept.getType(),new M200MsgCommonHdlr());
		map.put(20,new M200MsgCommonHdlr());
		map.put(21,new M200MsgCommonHdlr());
		map.put(22,new M200MsgCommonHdlr());
		map.put(23,new M200MsgCommonHdlr());
		map.put(40,new M200MsgCommonHdlr());
		
	}
	private void process(M200Iface mi) {
		this.mi=mi;
		display = new Display();
		cb = new Clipboard(display);
		tracedColor=display.getSystemColor(SWT.COLOR_BLUE);
		//tracedBGColor=display.getSystemColor(SWT.COLOR_GRAY);
		Listener filter= new Listener() {
			public void handleEvent(Event e) {
				if((e.stateMask&SWT.CONTROL)!=0 && e.keyCode==32){
					e.doit=false;
					e.type=SWT.None;  
					changePause();
				}
				}
		};
		display.addFilter(SWT.KeyDown,filter);
		
		Shell shell = new Shell(display);
		GridLayout shellLayout=new GridLayout(1,true);
		shell.setLayout(shellLayout);
		shell.addShellListener(this);
		shell.setText("Ocular 0.4");

	
		CTabFolder folder = new CTabFolder(shell, SWT.BORDER|SWT.BOTTOM);
		folder.setSimple(false);
		folder.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		folder.addKeyListener(this);
		
		tableRT = new Table(folder, SWT.BORDER | SWT.VIRTUAL|SWT.FULL_SELECTION);
		createTableColumn("Start", tableRT);
		createTableColumn("FromIn", tableRT);
		createTableColumn("FromOut", tableRT);
		createTableColumn("ToIn", tableRT);
		createTableColumn("ToOut", tableRT);
		createTableColumn("Update", tableRT);
		createTableColumn("Details", tableRT);
		tableRT.setHeaderVisible (true);
		tableRT.setLinesVisible (true);
		tableRT.addListener(SWT.SetData,this);
		tableRT.addKeyListener(this);
		tableRT.addSelectionListener(this);
		
		CTabItem itemRT = new CTabItem(folder, SWT.NONE);
		itemRT.setText("Realtime");
		itemRT.setControl(tableRT);
		folder.setSelection(itemRT);

		tableStat = new Table(folder, SWT.BORDER |SWT.FULL_SELECTION);
		createTableColumn("ReleaseCause", tableStat);
		createTableColumn("Count", tableStat);
		tableStat.setHeaderVisible (true);
		tableStat.setLinesVisible (true);
/*
		tableStat.addListener(SWT.SetData, new Listener() {
			public void handleEvent(Event event) {
			
			}
		});
	*/	
		CTabItem itemStat = new CTabItem(folder, SWT.NONE);
		itemStat.setText("Stat");
		itemStat.setControl(tableStat);
		

		
		tableCM = new Table(folder, SWT.BORDER | SWT.VIRTUAL|SWT.FULL_SELECTION);
		createTableColumn("1/1", tableCM);
		createTableColumn("1/2", tableCM);
		tableCM.setHeaderVisible (true);
		tableCM.setLinesVisible (true);
		//tableXS.addListener(SWT.SetData,this);
		//tableXS.addKeyListener(this);
		
		CTabItem itemCM = new CTabItem(folder, SWT.NONE);
		itemCM.setText("CallMatrix");
		itemCM.setControl(tableCM);

		
		
		
		final Composite composite = new Composite (shell, SWT.NONE);
		GridLayout layout = new GridLayout (3, false);
		layout.marginTop = layout.marginBottom = 5;
		layout.marginLeft  = layout.marginRight = 10;
		layout.verticalSpacing = 5;
		composite.setLayout(layout);
		
		nums0 = createNums(composite);
		nums1 = createNums(composite);
		
		Button button = new Button (composite, SWT.PUSH);
		button.setText("Trace");
		shell.setDefaultButton(button);
		
//		button.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, false));

		statusLabel = new Label(shell, SWT.BORDER);
		statusLabel.setAlignment(SWT.RIGHT);
		statusLabel.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, false, false));
		
		Control [] tabList1 = new Control [] {nums0,nums1,button};
		composite.setTabList (tabList1);

		Control [] tabList2 = new Control [] {composite};
		shell.setTabList (tabList2);
		nums0.setFocus();


		mi.process();
		new Thread(this).start();
		
		itemStat.setText("Stat "+Calendar.getInstance().get(Calendar.DAY_OF_MONTH)+" "+Calendar.getInstance().get(Calendar.HOUR)+":"+Calendar.getInstance().get(Calendar.MINUTE)+":"+Calendar.getInstance().get(Calendar.SECOND));
		
		shell.open();
		while (!shell.isDisposed()) {
		if (!display.readAndDispatch()) display.sleep();
		}
		display.dispose();
		System.exit(0);
	
	}

	private Text createNums(final Composite composite) {
		final Text text = new Text (composite, SWT.BORDER );
		Listener digitOnly= new Listener () {
			public void handleEvent (Event e) {
				String string = e.text;
				char [] chars = new char [string.length ()];
				string.getChars (0, chars.length, chars, 0);
				for (int i=0; i<chars.length; i++) {
					if (!('0' <= chars [i] && chars [i] <= '9')) {
						e.doit = false;
						return;
					}
				}
			}};
			ModifyListener resize= new ModifyListener() {
				public void modifyText(ModifyEvent e) {
					//System.err.println("'"+nums0.getText()+"'"+nums1.getText()+"'");
						tableRT.deselectAll();
						currDB.trace(nums0.getText(),nums1.getText());
						updateAll();
						text.pack();
						composite.pack();
					}
			};
		text.addListener (SWT.Verify,digitOnly);
		text.addModifyListener(resize);
		return text;
	}

	private TableColumn createTableColumn(String text, Table table) {
		final TableColumn tc0=new TableColumn(table,SWT.NONE);
		tc0.setText(text);
		tc0.pack();
		tc0.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				tc0.pack();
			}
		});
		return tc0;
	}

	@Override
	public void NewM200Message(M200Msg msg) {
		M200MsgHdlr h=map.get(msg.getBodyType());
		if(h!=null) if(h.process(msg,currDB)){
			updateAll();
		}
	}

	private void updateAll() {
		display.asyncExec(new Runnable () {
			public void run () {
				if (tableRT.isDisposed ()) return;
				updateStatus();
				tableRT.setItemCount(currDB.getNum());
				tableRT.clearAll();
			}
		});
	}

	private void updateStatus() {
		statusLabel.setText((paused?"paused":"")+" "+currDB.getStatusString());
	}

	@Override
	public void handleEvent(Event e) {
		TableItem item = (TableItem)e.item;
		int index = tableRT.indexOf(item);
		//item.setText(4,index+" "+currDB.getScrolled(index));
		switch(currDB.getTraced(index)){
		case 1: item.setForeground(3,tracedColor);item.setForeground(4,tracedColor); break;
		case 2: item.setForeground(1,tracedColor);item.setForeground(2,tracedColor); break;
		case 3: item.setForeground(tracedColor);break;
		}
		//if(currDB.isTraced(index)) item.setForeground(tracedColor);
		item.setText(0,currDB.getStartTime(index));
		item.setText(1,currDB.getFromIn(index));
		item.setText(2,currDB.getFromOut(index));
		item.setText(3,currDB.getToIn(index));
		item.setText(4,currDB.getToOut(index));
		item.setText(5,currDB.getUpdateTime(index));
		item.setText(6,currDB.getScrolled(index));

	}

	@Override
	public void keyPressed(KeyEvent e) {
		if(e.keyCode==32) changePause();
		
	}

	private void changePause() {
		paused = paused?currDB.processNew():currDB.skipNew();
	}

	@Override
	public void keyReleased(KeyEvent e) {
//		System.err.println(e.keyCode);
	}
	public void shellClosed(ShellEvent e){
		mi.stop();
	}

	@Override
	public void run() {
		while(true){
		try {
			Thread.sleep(5000);
			display.asyncExec(new Runnable () {
				public void run () {
					if (tableStat.isDisposed ()) return;
					tableStat.removeAll();
					for (Map.Entry<String, Integer> pair:currDB.getStats()){
						TableItem ti=new TableItem(tableStat, SWT.NONE);
						ti.setText(0,pair.getKey());
						ti.setText(1,pair.getValue().toString());
					}
				}
			});
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		}
	}

	@Override
	public void widgetDefaultSelected(SelectionEvent e) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void widgetSelected(SelectionEvent e) {
		TableItem ti[]=tableRT.getSelection();
		if (ti.length==0) return;
		String textData = ti[0].getText(6); 
		if (textData.length() > 0) {
			TextTransfer textTransfer = TextTransfer.getInstance();
			cb.setContents(new Object[]{textData}, new Transfer[]{textTransfer});
		}	
	}
}
